using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_Affairs
    /// </summary>
    public partial class T_Sys_Affairs
    {
        public T_Sys_Affairs()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Sys_Affairs");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Affairs");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Affairs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Affairs(");
            strSql.Append("F_WorkOrderId,TROWGUID,CASE_SERIAL,TSIGNTIME_BF,TBACKTIME_BF,SEND_TIME,SEND_CONTENT,CASE_TIME,TFDBACKTIME_BF,FILES,CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@TROWGUID,@CASE_SERIAL,@TSIGNTIME_BF,@TBACKTIME_BF,@SEND_TIME,@SEND_CONTENT,@CASE_TIME,@TFDBACKTIME_BF,@FILES,@CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,100),
                    new SqlParameter("@TROWGUID", SqlDbType.NVarChar,500),
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,500),
                    new SqlParameter("@TSIGNTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@TBACKTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@SEND_TIME", SqlDbType.NVarChar,500),
                    new SqlParameter("@SEND_CONTENT", SqlDbType.NVarChar,500),
                    new SqlParameter("@CASE_TIME", SqlDbType.NVarChar,500),
                    new SqlParameter("@TFDBACKTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@FILES", SqlDbType.NVarChar,50),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.TROWGUID;
            parameters[2].Value = model.CASE_SERIAL;
            parameters[3].Value = model.TSIGNTIME_BF;
            parameters[4].Value = model.TBACKTIME_BF;
            parameters[5].Value = model.SEND_TIME;
            parameters[6].Value = model.SEND_CONTENT;
            parameters[7].Value = model.CASE_TIME;
            parameters[8].Value = model.TFDBACKTIME_BF;
            parameters[9].Value = model.FILES;
            parameters[10].Value = model.CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Affairs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Affairs set ");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("TROWGUID=@TROWGUID,");
            strSql.Append("CASE_SERIAL=@CASE_SERIAL,");
            strSql.Append("TSIGNTIME_BF=@TSIGNTIME_BF,");
            strSql.Append("TBACKTIME_BF=@TBACKTIME_BF,");
            strSql.Append("SEND_TIME=@SEND_TIME,");
            strSql.Append("SEND_CONTENT=@SEND_CONTENT,");
            strSql.Append("CASE_TIME=@CASE_TIME,");
            strSql.Append("TFDBACKTIME_BF=@TFDBACKTIME_BF,");
            strSql.Append("FILES=@FILES,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,100),
                    new SqlParameter("@TROWGUID", SqlDbType.NVarChar,500),
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,500),
                    new SqlParameter("@TSIGNTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@TBACKTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@SEND_TIME", SqlDbType.NVarChar,500),
                    new SqlParameter("@SEND_CONTENT", SqlDbType.NVarChar,500),
                    new SqlParameter("@CASE_TIME", SqlDbType.NVarChar,500),
                    new SqlParameter("@TFDBACKTIME_BF", SqlDbType.NVarChar,500),
                    new SqlParameter("@FILES", SqlDbType.NVarChar,50),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.TROWGUID;
            parameters[2].Value = model.CASE_SERIAL;
            parameters[3].Value = model.TSIGNTIME_BF;
            parameters[4].Value = model.TBACKTIME_BF;
            parameters[5].Value = model.SEND_TIME;
            parameters[6].Value = model.SEND_CONTENT;
            parameters[7].Value = model.CASE_TIME;
            parameters[8].Value = model.TFDBACKTIME_BF;
            parameters[9].Value = model.FILES;
            parameters[10].Value = model.CreateTime;
            parameters[11].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Affairs ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Affairs ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Affairs GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_WorkOrderId,TROWGUID,CASE_SERIAL,TSIGNTIME_BF,TBACKTIME_BF,SEND_TIME,SEND_CONTENT,CASE_TIME,TFDBACKTIME_BF,FILES,CreateTime from T_Sys_Affairs ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Sys_Affairs model = new CallCenterApi.Model.T_Sys_Affairs();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }
        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Affairs GetModel(string F_WorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Sys_Affairs WITH(NOLOCK) ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,100)
            };
            parameters[0].Value = F_WorkOrderId;

            CallCenterApi.Model.T_Sys_Affairs model = new CallCenterApi.Model.T_Sys_Affairs();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Affairs DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Affairs model = new CallCenterApi.Model.T_Sys_Affairs();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["TROWGUID"] != null)
                {
                    model.TROWGUID = row["TROWGUID"].ToString();
                }
                if (row["CASE_SERIAL"] != null)
                {
                    model.CASE_SERIAL = row["CASE_SERIAL"].ToString();
                }
                if (row["TSIGNTIME_BF"] != null)
                {
                    model.TSIGNTIME_BF = row["TSIGNTIME_BF"].ToString();
                }
                if (row["TBACKTIME_BF"] != null)
                {
                    model.TBACKTIME_BF = row["TBACKTIME_BF"].ToString();
                }
                if (row["SEND_TIME"] != null)
                {
                    model.SEND_TIME = row["SEND_TIME"].ToString();
                }
                if (row["SEND_CONTENT"] != null)
                {
                    model.SEND_CONTENT = row["SEND_CONTENT"].ToString();
                }
                if (row["CASE_TIME"] != null)
                {
                    model.CASE_TIME = row["CASE_TIME"].ToString();
                }
                if (row["TFDBACKTIME_BF"] != null)
                {
                    model.TFDBACKTIME_BF = row["TFDBACKTIME_BF"].ToString();
                }
                if (row["FILES"] != null)
                {
                    model.FILES = row["FILES"].ToString();
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_WorkOrderId,TROWGUID,CASE_SERIAL,TSIGNTIME_BF,TBACKTIME_BF,SEND_TIME,SEND_CONTENT,CASE_TIME,TFDBACKTIME_BF,FILES,CreateTime ");
            strSql.Append(" FROM T_Sys_Affairs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_WorkOrderId,TROWGUID,CASE_SERIAL,TSIGNTIME_BF,TBACKTIME_BF,SEND_TIME,SEND_CONTENT,CASE_TIME,TFDBACKTIME_BF,FILES,CreateTime ");
            strSql.Append(" FROM T_Sys_Affairs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Affairs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Affairs T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Affairs";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
